/*************************************************************************************************
Copyright (c) 2000 BindView Corporation.  All rights reserved.  

By using this software, YOU AGREE to the following license terms.  IF YOU DO NOT AGREE, YOU MAY NOT USE THE SOFTWARE.  
1.  BindView believes that this software is safe for use in normal circumstances, and has performed what it believes to be reasonable but non-exhaustive testing to verify this.  The software is intended for use only by experienced and knowledgeable computer professionals; IT IS PROVIDED "AS IS, WITH ALL FAULTS," including source code so that the user can study the source code and independently determine the software's suitability.  BindView makes no warranty of any kind, express or implied, and DISCLAIMS ANY AND ALL WARRANTIES, CONDITIONS, OR IMPLIED TERM OF QUALITY, INCLUDING THE IMPLIED WARRANTIES OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A PARTICULAR PURPOSE.  All use of the software is entirely at the user's own risk.
2.  IN NO EVENT WILL BINDVIEW BE LIABLE FOR DAMAGES OF ANY KIND arising from or relating to use of the software, whether such damages are direct, indirect, incidental, consequential, exemplary, or any other kind, and whether arising under contract, tort (including negligence), strict liability, or otherwise.
3.  BindView will not object to your distribution of complete, unmodified copies of the distribution package of the software as provided by BindView, PROVIDED that you do not charge a fee other than a reasonable fee for distribution services.  You may charge a fee for any warranty or support services that you offer to purchasers of copies of the software.
4.  You may modify the software and distribute copies of the modified software, PROVIDED:
	(a) that you distribute, together with the executable code of the modified software:
		(1) the source code of the modified software, which must contain the BindView copyright notice set forth above (in addition to your own copyright notice if any); and
		(2) a copy of the complete, unmodified distribution package of the software as provided by BindView; and
	(b) that you clearly indicate in the source code and in an accompanying documentation file that the software is based on BindView's software and was modified by you; and
	(c) that you grant users of the modified software the same rights as are granted to you by this license.
**************************************************************************************************/
// ProjectXDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ProjectX.h"
#include "ProjectXDlg.h"
#include <afxhtml.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProjectXDlg dialog
void usage(char *prog);
void send_packets(u_long src_ip, const char *my_host, u_short sport, int antitype, int verbose);
void process_targets(const CArray<int, int> *phostlist, int verbose);
void build_class_c(u_long dst_ip);
void free_targets();

CProjectXDlg::CProjectXDlg(CWnd* pParent /*=NULL*/)
: CDialog(CProjectXDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProjectXDlg)
	m_UdpPort = 53;
	m_TFN = TRUE;
	m_TRINO = TRUE;
	m_STACHDR = TRUE;
	m_SHAFT = FALSE;
	m_NotInputFile = TRUE;
	m_Repeat = 10;
	m_TRINOFORWINDOWS = TRUE;
	m_ShaftHost = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CProjectXDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProjectXDlg)
	DDX_Control(pDX, IDC_SOURCE_IP, m_SourceIP);
	DDX_Control(pDX, IDC_IPDEST, m_DestIP);
	DDX_Text(pDX, IDC_UDP_PORT, m_UdpPort);
	DDV_MinMaxUInt(pDX, m_UdpPort, 0, 65535);
	DDX_Check(pDX, IDC_TFN, m_TFN);
	DDX_Check(pDX, IDC_TRINO, m_TRINO);
	DDX_Check(pDX, IDC_STACHDR, m_STACHDR);
	DDX_Check(pDX, IDC_SHAFT, m_SHAFT);
	DDX_Check(pDX, IDC_NOT_FILE, m_NotInputFile);
	DDX_Text(pDX, IDC_REPEAT, m_Repeat);
	DDV_MinMaxInt(pDX, m_Repeat, 1, 300);
	DDX_Check(pDX, IDC_TRINOFORWINDOWS, m_TRINOFORWINDOWS);
	DDX_Text(pDX, IDC_SHAFT_HOST, m_ShaftHost);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CProjectXDlg, CDialog)
//{{AFX_MSG_MAP(CProjectXDlg)
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
ON_BN_CLICKED(IDOK, OnCure)
ON_BN_CLICKED(IDC_FILE, OnInputFile)
ON_BN_CLICKED(IDC_NOT_FILE, OnNotFile)
ON_BN_CLICKED(IDC_REAL_ABOUT, OnRealAbout)
ON_BN_CLICKED(IDCANCEL2, OnCancel)
	ON_BN_CLICKED(IDC_SHAFT, OnShaft)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProjectXDlg message handlers

BOOL CProjectXDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	GetDlgItem(IDC_FILE)->EnableWindow(!m_NotInputFile);
	GetDlgItem(IDC_SHAFT_HOST)->EnableWindow(m_SHAFT);
	m_DestIP.EnableWindow(m_NotInputFile);
	GetDlgItem(IDC_NUM_OF_ADDR)->ShowWindow(!m_NotInputFile);
	GetDlgItem(IDC_TRG_TXT)->ShowWindow(!m_NotInputFile);
	
	GetDlgItem(IDC_FILE_NAME)->SetWindowText(_T(""));
	UpdateData();
	HOSTENT *hostent=NULL;
	hostent = gethostbyname("");
	if (hostent == NULL)
		return FALSE;
	unsigned long t;
	memcpy(&t,hostent->h_addr_list[0],sizeof(t));
	m_SourceIP.SetAddress(ntohl(t));
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CProjectXDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CProjectXDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CProjectXDlg::OnCure() 
{
	UpdateData();
	extern char *optarg;
	extern int optind;
	extern int optopt;
	extern int opterr;
	int setdev = 0;
	bool antitype = 0;
	u_long src_ip;
	u_long dst_ip = 0;
	u_long class_c_ip;
	u_short sport = 53;
	u_long CLASS_C_MASK = 0x00ffffff;
	char *dev;
	dev = "eth0";
	
	CString sourceIP;
	BYTE f0, f1, f2, f3;
	m_SourceIP.GetAddress(f0, f1, f2, f3);
	sourceIP.Format("%d.%d.%d.%d", f0, f1, f2, f3);
	src_ip = inet_addr(sourceIP);
	if (src_ip == -1)
	{
		TRACE("=== Invalid class C %s\n", sourceIP);
		if(m_UI)
			AfxMessageBox("Invalid class C");
		return;
	}
	src_ip = htonl(src_ip);
	
	m_classC = false;
	if(m_NotInputFile)
	{
		//if it is class C subnet
		m_DestIP.GetAddress(f0, f1, f2, f3);
		CString destIPAddr;
		destIPAddr.Format("%d.%d.%d.%d", f0, f1, f2, f3);
		dst_ip = inet_addr(destIPAddr);
		if (dst_ip == -1 || dst_ip == NULL)
		{
			TRACE("=== Invalid class C %s\n", destIPAddr);
			if(m_UI)
				AfxMessageBox("Invalid class C or IP address");
			return;
		}
		
		m_hostList.Add(dst_ip);
	}
	
	if (!f3) {
		/* get the last part of the address */
		class_c_ip = ((dst_ip | CLASS_C_MASK) - CLASS_C_MASK);
		/* if it is not zero make it zero */
		if(class_c_ip) dst_ip = dst_ip ^ class_c_ip;
		m_classC = true;
	}
	sport = m_UdpPort;
	if (!m_TRINO && !m_TRINOFORWINDOWS && !m_TFN && !m_STACHDR && !m_SHAFT) {
		AfxMessageBox(_T("Please select the Zombie type you wish to Zap!"));
		return;
	}

	if (m_SHAFT && m_ShaftHost.IsEmpty ()) {
		AfxMessageBox(_T("Please enter a flooded host for Shaft."));
                GetDlgItem(IDC_SHAFT_HOST)->SetFocus();
		return;
	}
	
	if (m_Repeat < 1 || m_Repeat > 300 )
	{
		return;
	}
	if(m_hostList.GetSize() == 0)
	{
		AfxMessageBox(_T("Targets not set!"));
		return;
	}
	//  m_hostList[0]= destIPAddr.GetBuffer(0);
	
	/* end post arg processing */
	
	/* build a class C full of addresses */
	if (m_classC) build_class_c(dst_ip);
	/* build target chain and get a count */
	else process_targets(&m_hostList, true);

	CWaitCursor wait;

	int counter = 0;
	while(counter++<m_Repeat)
	{
		CString progress;
		progress.Format(_T("Sending #%d"), counter);
		GetDlgItem(IDC_PROGRESS)->SetWindowText(progress);
		if (m_TRINO)
			send_packets(src_ip,NULL,sport,1,true);
		if (m_TFN)
			send_packets(src_ip,NULL,sport,2,true);
		if (m_STACHDR)
			send_packets(src_ip,NULL,sport,3,true);
		if (m_TRINOFORWINDOWS)
			send_packets(src_ip,NULL,sport,4,true);
		if (m_SHAFT) {
			send_packets(src_ip,NULL,sport,5,true);
			send_packets(src_ip,m_ShaftHost,sport,0,true);
                }
		Sleep(100);
	}	
	free_targets(); // Free up hostlist memory
	GetDlgItem(IDC_PROGRESS)->SetWindowText(_T(""));
	wait.Restore();
}

void CProjectXDlg::OnInputFile() 
{
	m_hostList.RemoveAll();
	CFileDialog dlg(TRUE, _T(".xml"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("Text Files (*.txt)|*.txt; *.txt |All Files (*.*)|*.*||"));
	if(IDCANCEL  == dlg.DoModal())
		return;
	TRACE(_T("File Name : %s\n"), dlg.GetPathName());
	GetDlgItem(IDC_FILE_NAME)->SetWindowText(dlg.GetPathName());
	CString ipAddr;
	try
	{
		CStdioFile file;
		int dst_ip;
		if(file.Open(dlg.GetPathName(), CFile::modeRead | CFile::typeText))
		{
			
			while(file.ReadString(ipAddr))
			{
				dst_ip = inet_addr(ipAddr);
				if (dst_ip == -1 || dst_ip == NULL)
				{
					TRACE("=== Invalid IP %s\n", ipAddr);
					continue;
				}
				m_hostList.Add(dst_ip);
			}
			CString tmp;
			tmp.Format(_T("%d"), m_hostList.GetSize());
			GetDlgItem(IDC_NUM_OF_ADDR)->SetWindowText(tmp);
		}
		
	}
	catch(CFileException *e)
	{
		TRACE(_T("Exception %d\n"), e->m_cause);
		CString error;
		error.Format(_T("Error(%d) occured while reading file %s"), e->m_cause, dlg.GetPathName());
		AfxMessageBox(error, MB_ICONERROR | MB_OK);
		e->Delete();
		return;
	}
	
}

void CProjectXDlg::OnNotFile() 
{
	m_NotInputFile = !m_NotInputFile;
	GetDlgItem(IDC_FILE)->EnableWindow(!m_NotInputFile);
	GetDlgItem(IDC_NUM_OF_ADDR)->ShowWindow(!m_NotInputFile);
	GetDlgItem(IDC_TRG_TXT)->ShowWindow(!m_NotInputFile);
	
	m_DestIP.EnableWindow(m_NotInputFile);
}

void CProjectXDlg::OnRealAbout() 
{
	CDialog dlg(IDD_ABOUT);
	dlg.DoModal();
	
}

void CProjectXDlg::OnShaft() 
{
	// TODO: Add your control notification handler code here
	m_SHAFT = !m_SHAFT;
        GetDlgItem(IDC_SHAFT_HOST)->EnableWindow(m_SHAFT);
}
